%Function that locates and plots corresponding points in to epipolar images
%Master is reference image and corresponding point is located in slave
%image

function index_col = correlation_epi(master,slave, row, col)

win_size = 14;                                                                       % Window size: (N+1) x (N+1)

%Normalize images
% master = master./max(max(master));
% slave = slave./max(max(slave));

win0 = master(row-win_size/2:row+win_size/2,col-win_size/2:col+win_size/2);         % Ref/Master window
E_w0 = mean(mean(win0));                                                            % Mean value of window
std_w0 = sqrt(mean(mean((win0-E_w0).^2)));                                          % Standard devation value

norm_corr = zeros(size(slave,2),1);

for i=0:(size(slave,2)-20)

    win1 = slave(row-win_size/2:row+win_size/2,col-win_size/2+i:col+win_size/2+i);  % Slave window 1
    E_w1 = mean(mean(win1));                                                        % Mean value of window 1
    std_w1 = sqrt(mean(mean((win1-E_w1).^2)));                                      % Standard devation value
    
    % Find the normalized correlation for each window along epipolar line
    % and shift half the window size in element number to adjust for 
    % centering
    norm_corr(i+win_size/2) = (mean(mean(win0.*win1))-E_w0*E_w1)/(std_w0*std_w1);

end


[~,index_col] = max(abs(norm_corr));                                                % Find which col. that has max corr.


%Show the images with points
% figure(1);
% imagesc(master);
% colormap(gray);
% title('Master image');
% hold on;
% plot(col,row, '.r')
% hold off;
% 
% figure(2);
% imagesc(slave);
% colormap(gray);
% title('Slave image');
% hold on;
% plot(index_col,row, '.g');
% hold off;

end