%Function that locates and plots corresponding points in to epipolar images
%Master is reference image and corresponding point is located in slave
%image

function [value, loc] = point_matching(master,slave, row, col)

win_size = 24;                                                              % Window size: (win_size+1) x (win_size+1) NB! Should be a even number
range = 10;                                                                 % Search  in columns for slave image 

win0 = master(row-win_size/2:row+win_size/2,col-win_size/2:col+win_size/2); % Ref/Master window
win1 = slave(row-win_size/2:row+win_size/2,col-range:col+range);            % Slave window 1 NB! Here it is assmued that the one of the images is shifted so that the images are moved together.
                                                                            % If not than the search area must probably be expanded by more than 100 pix. 

norm_corr = normxcorr2(win0, win1);

[value,loc] = max((norm_corr(win_size+1,win_size/2:end-win_size)));         % Find which col. that has max corr. and skip those values ouside col range to adjust for offset 

loc = loc + col-range;
                                                             

%Show the images with points
% figure(1);
% imagesc(master);
% colormap(gray);
% title('Master image');
% hold on;
% plot(col,row, '.r')
% hold off;
% 
% figure(2);
% imagesc(slave);
% colormap(gray);
% title('Slave image');
% hold on;
% plot(loc,row, '.g');
% hold off;

end